      subroutine CI22(p, results, ncol)
c returning 2->2 squared amplitudes at both the LO and NLO
      implicit none
      double precision s, u, results(3, 2, 0:1)
      double precision averagefactor, gdot, p(0:3, 4)
      double precision newcol1(4, 4), newcol2(4, 4)
      parameter (averagefactor=1.d0/4.d0/9.d0)
      integer i, j, k, ii, jj, kk, ncol
      external gdot
      include "calc.h"

      s=2.d0*gdot(p(0,1), p(0,2))
      u=-2.d0*gdot(p(0,1), p(0,4))

      call calcSunF()
      call calcForF(s, u)

      results=0.d0

      qqCtree=0.d0
      qqCloop=0.d0
      qqxCtree=0.d0
      qqxCloop=0.d0


      call Amptree(s, u)

      if(ncol.eq.-1) then

      newcol1=colvirt
      newcol2=colvirt
     
      if((mode.ne.'resum').and.(loop.eq.1).and.(RGE.eq.0)) then
      call Ampvirtual(s, u)
      endif

      elseif(ncol.eq.0) then

      newcol1=colvirt
      newcol2=colvirt

      elseif((ncol.eq.1).or.(ncol.eq.6)) then

      newcol1=0.d0
      newcol2=0.d0
      do i=1, 4
      do j=1, 4
      do k=1, 4
      newcol1(i, j)=newcol1(i, j)+colvirt(i, k)*colcor1(k, j)
      newcol2(i, j)=newcol2(i, j)+colvirt(i, k)*colcor3(k, j)
      enddo
      enddo
      enddo

      elseif((ncol.eq.2).or.(ncol.eq.5)) then

      newcol1=0.d0
      newcol2=0.d0
      do i=1, 4
      do j=1, 4
      do k=1, 4
      newcol1(i, j)=newcol1(i, j)+colvirt(i, k)*colcor2(k, j)
      newcol2(i, j)=newcol2(i, j)+colvirt(i, k)*colcor2(k, j)
      enddo
      enddo
      enddo

      elseif((ncol.eq.3).or.(ncol.eq.4)) then

      newcol1=0.d0
      newcol2=0.d0
      do i=1, 4
      do j=1, 4
      do k=1, 4
      newcol1(i, j)=newcol1(i, j)+colvirt(i, k)*colcor3(k, j)
      newcol2(i, j)=newcol2(i, j)+colvirt(i, k)*colcor1(k, j)
      enddo
      enddo
      enddo

      endif

      do i=1, 2
      do j=1, 3
      do k=0, 6
      do ii=1, 2
      do jj=1, 3
      do kk=0, 6

      if((zeronot2(j ,jj)*zeronot1(k, kk)).ne.0) then 

      results(1, 1, 0)=results(1, 1, 0)+1.d0*qqCtree(i, j, k)*
     -   qqCtree(ii, jj, kk)*newcol1(i, ii)*qqform(j, jj)*coupl(k, kk)

      results(2, 1, 0)=results(2, 1, 0)+1.d0*qqxCtree(i, j, k)*
     -   qqxCtree(ii, jj, kk)*newcol2(i, ii)*qqxform(j, jj)*coupl(k, kk)

      if((loop.eq.1).and.(RGE.eq.0)) then
      results(1, 1, 1)=results(1, 1, 1)+2.d0*qqCtree(i, j, k)*
     -   qqCloop(ii, jj, kk)*newcol1(i, ii)*qqform(j, jj)*coupl(k, kk) 

      results(2, 1, 1)=results(2, 1, 1)+2.d0*qqxCtree(i, j, k)*
     -   qqxCloop(ii, jj, kk)*newcol2(i, ii)*qqxform(j, jj)*coupl(k, kk) 
      endif

      endif

      enddo
      enddo
      enddo
      enddo
      enddo
      enddo


      do i=1, 4
      do j=1, 6
      do k=0, 6
      do ii=1, 4
      do jj=1, 6
      do kk=0, 6

      if((zeronot2(j ,jj)*zeronot1(k, kk)).ne.0) then 

      results(1, 2, 0)=results(1, 2, 0)+1.d0*qqCtree(i, j, k)*
     -   qqCtree(ii, jj, kk)*newcol1(i, ii)*qqform(j, jj)*coupl(k, kk)

      results(2, 2, 0)=results(2, 2, 0)+1.d0*qqxCtree(i, j, k)*
     -   qqxCtree(ii, jj, kk)*newcol2(i, ii)*qqxform(j, jj)*coupl(k, kk)

      if((loop.eq.1).and.(RGE.eq.0)) then
      results(1, 2, 1)=results(1, 2, 1)+2.d0*qqCtree(i, j, k)*
     -   qqCloop(ii, jj, kk)*newcol1(i, ii)*qqform(j, jj)*coupl(k, kk) 

      results(2, 2, 1)=results(2, 2, 1)+2.d0*qqxCtree(i, j, k)*
     -   qqxCloop(ii, jj, kk)*newcol2(i, ii)*qqxform(j, jj)*coupl(k, kk) 
      endif

      endif

      enddo
      enddo
      enddo
      enddo
      enddo
      enddo

      results(3, 2, 0)=results(2, 2, 0)

      do i=3, 4
      do j=4, 6
      do k=0, 6
      do ii=3, 4
      do jj=4, 6
      do kk=0, 6

      if((zeronot2(j ,jj)*zeronot1(k, kk)).ne.0) then 

      results(2, 2, 0)=results(2, 2, 0)+(5.d0-1.d0)*1.d0
     -   *qqxCtree(i, j, k)* 
     -   qqxCtree(ii, jj, kk)*newcol2(i, ii)*
     -   qqxform(j, jj)*coupl(k, kk)

      results(3, 1, 0)=results(3, 1, 0)+1.d0
     -   *qqxCtree(i, j, k)* 
     -   qqxCtree(ii, jj, kk)*newcol2(i, ii)*
     -   qqxform(j, jj)*coupl(k, kk)

      if((loop.eq.1).and.(RGE.eq.0)) then
      results(2, 2, 1)=results(2, 2, 1)+(5.d0-1.d0)*2.d0
     -   *qqxCtree(i, j, k)* 
     -   qqxCloop(ii, jj, kk)*newcol2(i, ii)*
     -   qqxform(j, jj)*coupl(k, kk)
      endif

      endif

!nf=5.d0 here for the outside particles

      enddo
      enddo
      enddo
      enddo
      enddo
      enddo

      do i=1, 3
      do j=1, 2
      do k=0, 1
      results(i, j, k)=averagefactor*results(i, j, k)
      enddo
      enddo
      enddo


      do k=0, 1
      results(1, 2, k)=results(1, 2, k)/2.d0
      enddo

      end subroutine

