      subroutine intdipp(k,n,p,x,results)
      implicit none
c integrated dipole subtraction term P_m+a+b, g u -> ...
c k=1(splitting from a), k=2(splitting from b), n=0(delta(1-x)),
c  n=1(regular), n=2(plus(1/(1-x))), n=3, n=4      
      double precision s, t, u, x, psplit, lgfot, CF, results(3, 2)
      double precision p(0:3, 4), gdot, colorsq(3, 2, 0:3), pplus
      double precision lgfou, lgfos
      double precision aux(3, 2, 0:1)
      integer i,j,l,n,k
      parameter (CF=4.d0/3.d0)
      external psplit, gdot, pplus
      include "var.inc"

      do i=0, 3
      call dipoleCI22(p, aux, i)
      do j=1, 3
      do l=1, 2
      colorsq(j, l, i)=aux(j, l, 0)
      enddo
      enddo
      enddo

      results=0.d0
      
      s=2.d0*gdot(p(0, 1), p(0, 2))
      t=-2.d0*gdot(p(0, 1), p(0, 3))
      u=-2.d0*gdot(p(0, 1), p(0, 4))
      lgfot=dlog(-facscale**2/t)
      lgfou=dlog(-facscale**2/u)
      lgfos=dlog(facscale**2/s)

      if(n.le.2) then

      do i=1, 2
      do j=1, 2

      results(i, j)=results(i, j)+psplit(1, 1, n, x)/CF*
     -   (lgfos*colorsq(i, j, 1)+lgfot*colorsq(i, j, 2)
     -   +lgfou*colorsq(i, j, 3))

      enddo
      enddo

      if(k.eq.2) then
      
      do i=1, 2

      results(3, 1)=results(3, 1)+psplit(0, 1, n, x)/CF*
     -   (lgfos*colorsq(i, 1, 1)+lgfot*colorsq(i, 1, 2)
     -   +lgfou*colorsq(i, 1, 3))*(nf-1.d0)

      enddo

      do i=1, 2

      results(3, 1)=results(3, 1)+psplit(0, 1, n, x)/CF*
     -   (lgfos*colorsq(i, 2, 1)+lgfot*colorsq(i, 2, 2)
     -   +lgfou*colorsq(i, 2, 3))

      enddo

      endif

      endif

      results=alfas/2.d0/pi*results*pplus(n, x)
      
      end subroutine

